unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, Buttons, RXSlider, MPEGPlayer, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    RxSlider1: TRxSlider;
    PlayBtn: TBitBtn;
    StopBtn: TBitBtn;
    PauseBtn: TBitBtn;
    BitBtn4: TBitBtn;
    Timer1: TTimer;
    Label1: TLabel;
    LengthLabel: TLabel;
    MPlayer: TMPEGPlayer;
    procedure PlayBtnClick(Sender: TObject);
    procedure PauseBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure RxSlider1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    DontSeek : boolean;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.PlayBtnClick(Sender: TObject);
begin
  MPlayer.Play;
end;

procedure TForm1.PauseBtnClick(Sender: TObject);
begin
  MPlayer.paused:=not (Mplayer.Paused);
end;

procedure TForm1.StopBtnClick(Sender: TObject);
begin
  if MPlayer.Mode>2 then
  begin
    MPlayer.Stop;
    MPlayer.Close;
  end;
  RXSlider1.value:=0;
  PlayBtn.Enabled:=false;
  StopBtn.Enabled:=false;
  PauseBtn.Enabled:=false;
end;

procedure TForm1.BitBtn4Click(Sender: TObject);
var s:string;
begin
  if not OpenDialog1.Execute then exit;
  MPlayer.AutoPlay:=false;
  MPlayer.StreamName:=OpenDialog1.FileName;
  MPlayer.Open;
  RxSlider1.MaxValue:=MPlayer.Length;
  RXSlider1.value:=0;
  Str(RxSlider1.MaxValue, s);
  LengthLabel.Caption:=s;
  PlayBtn.Enabled:=true;
  StopBtn.Enabled:=true;
  PauseBtn.Enabled:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  MPlayer.PathToDLL:='c:\winnt\system32\';
  MPlayer.init;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (MPlayer.mode=3) then
  begin
    DontSeek:=true;
    RXSlider1.value:=MPlayer.CurrentPosition;
    DontSeek:=false;
  end;
  if MPlayer.PlayStopped then
  begin
    MPlayer.Close;
    RXSlider1.value:=0;
    PlayBtn.Enabled:=false;
    StopBtn.Enabled:=false;
    PauseBtn.Enabled:=false;
  end;
end;

procedure TForm1.RxSlider1Change(Sender: TObject);
begin
  if not (DontSeek) then
    if (MPlayer.mode=3) or ((MPlayer.mode=4))
      then MPlayer.CurrentPosition:=RXSlider1.value;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MPlayer.Deinit;
end;

end.
